# ISystemProperties Interface Reference

The ISystemProperties interface represents global properties of the given VirtualBox installation. More...

List of all members.

## Public Attributes
readonly attribute unsigned long | minGuestRAM
| Minimum guest system memory in Megabytes.
readonly attribute unsigned long | maxGuestRAM
| Maximum guest system memory in Megabytes.
readonly attribute unsigned long | minGuestVRAM
| Minimum guest video memory in Megabytes.
readonly attribute unsigned long | maxGuestVRAM
| Maximum guest video memory in Megabytes.
readonly attribute unsigned long | minGuestCPUCount
| Minimum CPU count.
readonly attribute unsigned long | maxGuestCPUCount
| Maximum CPU count.
readonly attribute unsigned long long | maxVDISize
| Maximum size of a virtual disk image in Megabytes.
readonly attribute unsigned long | networkAdapterCount
| Number of network adapters associated with every IMachine instance.
readonly attribute unsigned long | serialPortCount
| Number of serial ports associated with every IMachine instance.
readonly attribute unsigned long | parallelPortCount
| Number of parallel ports associated with every IMachine instance.
readonly attribute unsigned long | maxBootPosition
| Maximum device position in the boot order.
attribute wstring | defaultMachineFolder
| Full path to the default directory used to create new or open existing machines when a settings file name contains no path.
attribute wstring | defaultHardDiskFolder
| Full path to the default directory used to create new or open existing virtual disks.
readonly attribute IHardDiskFormat[] | hardDiskFormats
| List of all hard disk storage formats supported by this VirtualBox installation.
attribute wstring | defaultHardDiskFormat
| Identifier of the default hard disk format used by VirtualBox.
attribute wstring | remoteDisplayAuthLibrary
| Library that provides authentication for VRDP clients.
attribute wstring | webServiceAuthLibrary
| Library that provides authentication for webservice clients.
attribute boolean | HWVirtExEnabled
| This specifies the default value for hardware virtualization extensions.
attribute unsigned long | LogHistoryCount
| This value specifies how many old release log files are kept.

## Detailed Description

The ISystemProperties interface represents global properties of the given VirtualBox installation.

These properties define limits and default values for various attributes and parameters. Most of the properties are read-only, but some can be changed by a user.

Interface ID:
  `{0760E03F-06D0-481E-9F81-BE43FEF092BA}`

## Member Data Documentation

readonly attribute unsigned long ISystemProperties::minGuestRAM

Minimum guest system memory in Megabytes.

readonly attribute unsigned long ISystemProperties::maxGuestRAM

Maximum guest system memory in Megabytes.

readonly attribute unsigned long ISystemProperties::minGuestVRAM

Minimum guest video memory in Megabytes.

readonly attribute unsigned long ISystemProperties::maxGuestVRAM

Maximum guest video memory in Megabytes.

readonly attribute unsigned long ISystemProperties::minGuestCPUCount

Minimum CPU count.

readonly attribute unsigned long ISystemProperties::maxGuestCPUCount

Maximum CPU count.

readonly attribute unsigned long long ISystemProperties::maxVDISize

Maximum size of a virtual disk image in Megabytes.

readonly attribute unsigned long ISystemProperties::networkAdapterCount

Number of network adapters associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::serialPortCount

Number of serial ports associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::parallelPortCount

Number of parallel ports associated with every IMachine instance.

readonly attribute unsigned long ISystemProperties::maxBootPosition

Maximum device position in the boot order.

This value corresponds to the total number of devices a machine can boot from, to make it possible to include all possible devices to the boot list.

See also:
  IMachine::setBootOrder

attribute wstring ISystemProperties::defaultMachineFolder

Full path to the default directory used to create new or open existing machines when a settings file name contains no path.

The initial value of this property is `<`VirtualBox_home`>/Machines`.

Note:
  Setting this property to `null` will restore the initial value.

  When settings this property, the specified path can be absolute (full path) or relative to the VirtualBox home directory. When reading this property, a full path is always returned.

  The specified path may not exist, it will be created when necessary.

See also:
  IVirtualBox::createMachine, IVirtualBox::openMachine

attribute wstring ISystemProperties::defaultHardDiskFolder

Full path to the default directory used to create new or open existing virtual disks.

This path is used when the storage unit of a hard disk is a regular file in the host's file system and only a file name that contains no path is given.

The initial value of this property is `<`VirtualBox_home`>/HardDisks`.

Note:
  Setting this property to `null` will restore the initial value.

  When settings this property, the specified path can be relative to the VirtualBox home directory or absolute. When reading this property, a full path is always returned.

  The specified path may not exist, it will be created when necessary.

See also:
  IHardDisk, IVirtualBox::createHardDisk, IVirtualBox::openHardDisk, IMedium::location

readonly attribute IHardDiskFormat [] ISystemProperties::hardDiskFormats

List of all hard disk storage formats supported by this VirtualBox installation.

Keep in mind that the hard disk format identifier (IHardDiskFormat::id) used in other API calls like IVirtualBox::createHardDisk to refer to a particular hard disk format is a case-insensitive string. This means that, for example, all of the following strings:

              "VDI"
              "vdi"
              "VdI"

refer to the same hard disk format.

Note that the virtual hard disk framework is backend-based, therefore the list of supported formats depends on what backends are currently installed.

See also:
  IHardDiskFormat,

attribute wstring ISystemProperties::defaultHardDiskFormat

Identifier of the default hard disk format used by VirtualBox.

The hard disk format set by this attribute is used by VirtualBox when the hard disk format was not specified explicitly. One example is IVirtualBox::createHardDisk with the `null` format argument. A more complex example is implicit creation of differencing hard disks when taking a snapshot of a virtual machine: this operation will try to use a format of the parent hard disk first and if this format does not support differencing hard disks the default format specified by this argument will be used.

The list of supported hard disk formats may be obtained by the hardDiskFormats call. Note that the default hard disk format must have a capability to create differencing hard disks; otherwise opeartions that create hard disks implicitly may fail unexpectedly.

The initial value of this property is `VDI` in the current version of the VirtualBox product, but may change in the future.

Note:
  Setting this property to `null` will restore the initial value.

See also:
  hardDiskFormats, IHardDiskFormat::id, IVirtualBox::createHardDisk

attribute wstring ISystemProperties::remoteDisplayAuthLibrary

Library that provides authentication for VRDP clients.

The library is used if a virtual machine's authentication type is set to "external" in the VM RemoteDisplay configuration.

The system library extension (".DLL" or ".so") must be omitted. A full path can be specified; if not, then the library must reside on the system's default library path.

The default value of this property is `VRDPAuth`. There is a library of that name in one of the default VirtualBox library directories.

For details about VirtualBox authentication libraries and how to implement them, please refer to the VirtualBox manual.

Note:
  Setting this property to `null` will restore the initial value.

attribute wstring ISystemProperties::webServiceAuthLibrary

Library that provides authentication for webservice clients.

The library is used if a virtual machine's authentication type is set to "external" in the VM RemoteDisplay configuration and will be called from within the IWebsessionManager::logon implementation.

As opposed to ISystemProperties::remoteDisplayAuthLibrary, there is no per-VM setting for this, as the webservice is a global resource (if it is running). Only for this setting (for the webservice), setting this value to a literal "null" string disables authentication, meaning that IWebsessionManager::logon will always succeed, no matter what user name and password are supplied.

The initial value of this property is `VRDPAuth`, meaning that the webservice will use the same authentication library that is used by default for VBoxVRDP (again, see ISystemProperties::remoteDisplayAuthLibrary). The format and calling convention of authentication libraries is the same for the webservice as it is for VBoxVRDP.

attribute boolean ISystemProperties::HWVirtExEnabled

This specifies the default value for hardware virtualization extensions.

If enabled, virtual machines will make use of hardware virtualization extensions such as Intel VT-x and AMD-V by default. This value can be overridden by each VM using their IMachine::HWVirtExEnabled property.

attribute unsigned long ISystemProperties::LogHistoryCount

This value specifies how many old release log files are kept.